//CharteDeCouleurs_401f.js
// 04.04.11 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Crer une charte de couleurs

//// les rglages par dfaut /////////////////////////////////////////////////////////////////////
var yD = 10; // la distance (en mm) du bord suprieur da la page
var xD = 10; // la distance (en mm) du le bord gauche da la page
var nF = 21; // la valeur limite (le document est cach quand il y a davantage de blocs par range)
//// les rglages par dfaut /////////////////////////////////////////////////////////////////////

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester s'il y a un document ouvert
var noDoc = false;
if (app.documents.length == 0) {
	noDoc = true;
}
else {
	// mmoriser le chemin du document
	var curDoc = app.documents[0];
	try {
		var docFolder = curDoc.filePath;
		var docPath   = curDoc.fullName;
	}
	catch (e) {
		alert ("Enregistrer le document.", "Attention");
		exit();
	}
}

// appeler la fonction qui lit les rglages enregistrs
var allPrefs = getPrefs();
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var cSt   = prefVal[0];
	if (cSt  == "true") { cSt = true; } else { cSt = false; }
	var mSt   = prefVal[1];
	if (mSt  == "true") { mSt = true; } else { mSt = false; }
	var ySt   = prefVal[2];
	if (ySt  == "true") { ySt = true; } else { ySt = false; }
	var kSt   = prefVal[3];
	if (kSt  == "true") { kSt = true; } else { kSt = false; }
	var cFix  = prefVal[4]*1;
	var mFix  = prefVal[5]*1;
	var yFix  = prefVal[6]*1;
	var kFix  = prefVal[7]*1;
	var xVal  = prefVal[8]*1;
	var stVal = prefVal[9]*1;
	var zVal  = prefVal[10]*1;
	var wdVal = prefVal[11]*1;
	var dVal  = prefVal[12]*1;
	var rVal  = prefVal[13];
	var rb01  = 1;
	var rb02  = 0;
	if (rVal == "1") {
		rb01 = 0;
		rb02 = 1;
	}
	var mVal  = prefVal[14];
	var rb03  = 1;
	var rb04  = rb05 = rb06 = 0;
	if (mVal == "1") {
		rb03 = 0;
		rb04 = 1;
	}
	else if (mVal == "2") {
		rb03 = 0;
		rb05 = 1;
	}
	else if (mVal == "3") {
		rb03 = 0;
		rb06 = 1;
	}
}
else {
	// lorsque le fichier des prfrences ne peut pas tre trouv, 
	// utiliser les valeurs par dfaut suivants
	var cFix  =   0;
	var cSt   =   0;
	var mFix  =   0;
	var mSt   =   1;
	var yFix  =   0;
	var ySt   =   0;
	var kFix  =   0;
	var kSt   =   1;
	var xVal  =   0;
	var stVal =   5;
	var zVal  = 100;
	var wdVal =   5;
	var dVal  =   1;
	var rb01  =   1;
	var rb02  =   0;
	var rb03  =   1;
	var rb04  =   0;
	var rb05  =   0;
	var rb06  =   0;
}

// dfinir "Jaune" et "Noir"
if ((app.locale)*1 == 1279477362) { // InDesign en franais
	var yChar = "J";
	var kChar = "N";
	var yelloCol = "Jaune";
	var blackCol = "Noir";
}
else if ((app.locale)*1 == 1279477613) { // InDesign en allemand
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Gelb";
	var blackCol = "Schwarz";
}
else if ((app.locale)*1 == 1279477102 || (app.locale)*1 == 1279477097) { // InDesign en anglais
	var yChar = "Y";
	var kChar = "K";
	var yelloCol = "Yellow";
	var blackCol = "Black";
}
else {
	var yChar = "J";
	var kChar = "N";
	var yelloCol = "Jaune";
	var blackCol = "Noir";
}

// appeler la fonction qui affiche le dialogue et convertit les valeurs
var anArray = displayDialog();

// mettre le rsultat aux variables
var cDec = anArray[0];
var mDec = anArray[1];
var yDec = anArray[2];
var kDec = anArray[3];
var cPc  = anArray[4]*1;
var mPc  = anArray[5]*1;
var yPc  = anArray[6]*1;
var kPc  = anArray[7]*1;
var col1 = anArray[8];
var col2 = anArray[9];
var col3 = anArray[10];
var col4 = anArray[11];
var nFix = anArray[12]*1;
var xPc  = anArray[13]*1;
var sPc  = anArray[14]*1;
var zPc  = anArray[15]*1;
var fW   = anArray[16]*1;
var fH   = fW;
var dV   = anArray[17]*1;
var fDec = anArray[18];
var rDec = anArray[19];

// quand aucun composant de couleur fixe n'est slectionn, on doit dfinir
// lesquelles des paires de composants doivent tre superposes
if (nFix == 0) {
	var bDialog = app.dialogs.add({name:"Dfinir les paires de composants de couleur"});
	with (bDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Slectionner parmi les quatre composants"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"les deux paires  superposer"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col1 + " + " + col2 + "   |   " + col3 + " + " + col4, checkedState:1});
						radiobuttonControls.add({staticLabel:col1 + " + " + col3 + "   |   " + col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col1 + " + " + col4 + "   |   " + col2 + " + " + col3, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(bDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// si le bouton 2 ou 3 est slectionn, croiser la dfinition
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col2;
			col2 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol1 = col2;
			var tmpCol2 = col3;
			col2 = col4;
			col3 = tmpCol1;
			col4 = tmpCol2;
		}
		// supprimer le dialogue
		bDialog.destroy();
	}
	else {
		bDialog.destroy();
		exit();
	}
}
// quand un seul composant de couleur fixe est slectionn, on doit dfinir
// une paire de composants  superposer
else if (nFix == 1) {
	var cDialog = app.dialogs.add({name:"Dfinir la paire de composants"});
	with (cDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Slectionner parmi les trois composants"});
						staticTexts.add({staticLabel:" "});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"la paire  superposer"});
						staticTexts.add({staticLabel:" "});
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:70});
					with(decButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:col2 + " + " + col3, checkedState:1});
						radiobuttonControls.add({staticLabel:col2 + " + " + col4, checkedState:0});
						radiobuttonControls.add({staticLabel:col3 + " + " + col4, checkedState:0});
					}
					staticTexts.add({staticLabel:" ", minWidth:40});
				}
			}
		}
	}
	if(cDialog.show() == true) {
		var comDec = decButtons.selectedButton;
		// si le bouton 2 ou 3 est slectionn, croiser la dfinition
		if (comDec == 1) {
			var tmpCol = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		else if (comDec == 2) {
			var tmpCol = col2;
			col2 = col3;
			col3 = col4;
			col4 = tmpCol;
		}
		// supprimer le dialogue
		cDialog.destroy();
	}
	else {
		cDialog.destroy();
		exit();
	}
}

if (noDoc == false) {
	// mmoriser les units de mesure
	// lorsque ce n'est pas 2053991795 (= millimtres), changer  millimtres
	hM = curDoc.viewPreferences.horizontalMeasurementUnits;
	vM = curDoc.viewPreferences.verticalMeasurementUnits;
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// modifier le point zro  zro/zro
	var zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
	// dverrouiller le calque actif (si ncessaire)
	var isLocked = false;
	var curLayer = app.activeWindow.activeLayer;
	if (curLayer.locked) {
		curLayer.locked = false;
		isLocked = true;
	}
}

// calculer le nombre de blocs d'une range
var mN = ((zPc - xPc) + sPc) / sPc;

// quand la distance entre rangs et colonne est zro, la modifier  -0.1 mm (= des raccords meilleurs  l'cran)
if (dV == 0) { dV = -0.1; }

// calculer la dimension minimale du document
var docW = Math.floor((mN * fW) + ((mN-1)*dV) + (xD*2));

if (noDoc) {
	if (docW > 5486.4) {
		var diffVal = docW-5486.4;
		alert ("La largeur du document ncessaire (= " + docW + " mm) \nest de " + diffVal + " mm au-del de la valeur maximale (= 5486.4 mm). \n\nO bien des blocs plus petits o bien un pas plus grand.", "Stop");
		exit();
	}
	// crer un document
	if (mN > nF) { // invisiblement (quand le nombre de blocs est au-dessus de la valeur dfinie)
		curDoc = app.documents.add(false, undefined);
	}
	else { // sinon l'afficher
		curDoc = app.documents.add();
	}
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.documentPreferences.properties = {pageWidth:docW, pageHeight:docW, facingPages:false};
}
else {
	// vrifier si le document est assez grand
	var pWidth  = curDoc.documentPreferences.pageWidth;
	var pHeight = curDoc.documentPreferences.pageHeight;
	if (pWidth < (docW-xD) || pHeight < (docW-xD)) {
		alert ("Le document est trop petit.\n\nIl devrait mesurer " + docW + " mm x " + docW + " mm.", "Stop");
		resetAsBefore();
		exit();
	}
	if (mN > nF) { // quand le nombre de blocs est au-dessus de la valeur limite...
		// ... enregistrer le document, le fermer...
		curDoc.close(SaveOptions.yes);
		// ... et l'ouvrir invisiblement
		curDoc = app.open(File(docPath), false);
	}
}

// dsactiver le rafrachissement...
if (fDec == 0) {
	app.scriptPreferences.enableRedraw = false;
}
else {
	app.scriptPreferences.enableRedraw = true;
}

// allouer les valeurs fixes dfinies aux variables c m y k
var c = m = y = k = 0;
if (cDec) { c = cPc; }
if (mDec) { m = mPc; }
if (yDec) { y = yPc; }
if (kDec) { k = kPc; }
// rduire les valeurs des composants variables par la valeur "pas"
if      (col1 == "Cyan")    { c = xPc-sPc; pt1 = 0; }
else if (col1 == "Magenta") { m = xPc-sPc; pt1 = 1; }
else if (col1 == yelloCol)  { y = xPc-sPc; pt1 = 2; }
else if (col1 == blackCol)  { k = xPc-sPc; pt1 = 3; }
if      (col2 == "Cyan")    { c = xPc-sPc; pt2 = 0; }
else if (col2 == "Magenta") { m = xPc-sPc; pt2 = 1; }
else if (col2 == yelloCol)  { y = xPc-sPc; pt2 = 2; }
else if (col2 == blackCol)  { k = xPc-sPc; pt2 = 3; }
if      (col3 == "Cyan")    { c = xPc-sPc; pt3 = 0; }
else if (col3 == "Magenta") { m = xPc-sPc; pt3 = 1; }
else if (col3 == yelloCol)  { y = xPc-sPc; pt3 = 2; }
else if (col3 == blackCol)  { k = xPc-sPc; pt3 = 3; }
if      (col4 == "Cyan")    { c = xPc-sPc; pt4 = 0; }
else if (col4 == "Magenta") { m = xPc-sPc; pt4 = 1; }
else if (col4 == yelloCol)  { y = xPc-sPc; pt4 = 2; }
else if (col4 == blackCol)  { k = xPc-sPc; pt4 = 3; }

// vrifier s'il y a d'autres couleurs ( part des quatre couleurs de base)
allSwatches = app.documents[0].swatches.everyItem().name;
if (allSwatches.length > 4) {
	// si c'est le cas, il va falloir vrifier si une nuance  crer n'existe pas dj
	makeSure = true;
}
else {
	var makeSure = false;
}

// prparer les valeurs de dcalage et de la position de dpart verticale
var yOff  = fH+dV;
var xOff  = fW+dV;
var y1    = yD-yOff;

// prparer les variables slon le message d'information dsir...
if (rDec == 1) {
	var tenPc   = (mN*mN)/10;
	var testVal = tenPc;
}
// ... ou bien la barre de progression
else if (rDec == 3 && nFix != 3) {
	app.scriptPreferences.enableRedraw = true;
	
	//////////////////  Progressbar  dbut  //////////////////////////////////////////////////////////////
	
	//------------------------------------------------------------------------------
	// les constantes
	//------------------------------------------------------------------------------
	// le nombre de millisecondes avant l'ouverture de la barre de progression
	ProgressBar.openWindowDelay = 150;
	// la pause en millisecondes avant le rafrachissement de la barre de progression
	ProgressBar.updateDelay = 100;
	
	//------------------------------------------------------------------------------
	// le constructeur
	//------------------------------------------------------------------------------
	function ProgressBar(text, windowtitle, canceltext) {
		this.text = text;
		this.windowtitle = windowtitle;
		this.canceltext = canceltext;
		this.isopen = false;
		this.startTime = new Date().getTime();
		this.lastUpdate = 0;
		this.win = null;
		this.sections = new Array();
		this.progress = 0;
		
		this.newSection(1, text, 1);
		
	} // ProgressBar
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.newSection
	// subdiviser la barre de progression
	// doit tre lie  un appel de "sectionCompleted"
	// le titre et "fractionOfParentStep" sont des arguments optionels
	//------------------------------------------------------------------------------
	ProgressBar.prototype.newSection = function(numSteps, title, fractionOfParentStep) {
		if (fractionOfParentStep == undefined)
			fractionOfParentStep = 1;
		if (title == undefined)
			title = "";
		var numSections = this.sections.length;
		var start = (numSections > 0 ? this.sections[numSections-1].getTotalFractionComplete() : 0);
		var stepFraction = (numSections > 0 ? this.sections[numSections-1].fractionPerStep : 1);
		var newSection = new ProgressSection(title, start, start + (stepFraction * fractionOfParentStep), numSteps, fractionOfParentStep);
		this.sections.push(newSection);
		if (title != "")
			this.updateText(title);
	} // ProgressBar.prototype.newSection
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionStepFractionCompleted
	// est appel quand une partie de la section actuelle est complte
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionStepFractionCompleted = function(fraction) {
		var numSections = this.sections.length;
		if (numSections > 0) {
			var section = this.sections[numSections - 1];
			section.stepFractionComplete(fraction);
			this.updateProgress(section.getTotalFractionComplete());
		}
	} // ProgressBar.prototype.sectionStepFractionCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionStepCompleted
	// est appel quand un pas de la section actuelle est complt
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionStepCompleted = function() {
		var numSections = this.sections.length;
		if (numSections > 0) {
			var section = this.sections[numSections - 1];
			section.stepComplete();
			this.updateProgress(section.getTotalFractionComplete());
		}
	} // ProgressBar.prototype.sectionStepCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.sectionCompleted
	// est appel quand la section actuelle est complte
	//------------------------------------------------------------------------------
	ProgressBar.prototype.sectionCompleted = function() {
		var section = this.sections.pop();
		var numSections = this.sections.length;
		if (numSections > 0) {
			var parent = this.sections[numSections - 1];
			parent.stepFractionComplete(section.fractionOfParent);
			this.updateProgress(parent.getTotalFractionComplete());
			if (parent.title != '' && section.title != '')
				this.updateText(parent.title);
		}
	} // ProgressBar.prototype.sectionCompleted
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.close
	//------------------------------------------------------------------------------
		
	ProgressBar.prototype.close = function () {
		if (this.isopen) {
			this.win.close();
			this.isopen = false;
		}
	} // ProgressBar.prototype.close
		
	//------------------------------------------------------------------------------
	// LA FIN DE LA SECTION "PUBLIC"
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.open
	//------------------------------------------------------------------------------
	ProgressBar.prototype.open = function() {
		if (!this.isopen) {
			this.win = new Window('palette', this.windowtitle, undefined, { closeButton: false});
			this.win.main = this.win.add('group',[100,100,480,300]);
			this.win.main.margins = [15,0,15,0];
			this.win.main.orientation = 'column';
			var group = this.win.main.add('group');
			group.orientation = 'column';
			group.alignChildren = ['left', 'fill'];
			this.win.displaytext = group.add('statictext', undefined, this.text);
			this.win.displaytext.preferedSize = [350,60];
			this.win.progressbar = group.add('progressbar', undefined, 0, 1);
			this.win.progressbar.minimumSize.width = 320;
			group.add('statictext', undefined, this.canceltext);
			this.win.layout.layout(true);
			this.win.show();
			this.isopen = true;
		}
	} // ProgressBar.prototype.open
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.updateText
	//------------------------------------------------------------------------------
	ProgressBar.prototype.updateText = function(text) {
		if (this.isopen) {
			if (this.text != text) {
				this.win.displaytext.text = text;
			}
		}
		this.text = text;
	} // ProgressBar.prototype.updateText
	
	//------------------------------------------------------------------------------
	// ProgressBar.prototype.updateProgress
	//------------------------------------------------------------------------------
	ProgressBar.prototype.updateProgress = function(progressValue) {
		var now = new Date().getTime();
		if (!this.isopen) {
			if (now - this.startTime >= ProgressBar.openWindowDelay) {
				this.progress = progressValue;
				this.open();
			}
		} else {
			if (progressValue > this.progress) {
				this.progress = progressValue;
				if (now - this.lastUpdate >= ProgressBar.updateDelay) {
					this.lastUpdate = now;
					this.win.progressbar.value = progressValue;
				}
			}
		}
	} // ProgressBar.prototype.updateProgress
	
	//------------------------------------------------------------------------------
	// dfinir et implmenter l'objet ProgressSection
	//------------------------------------------------------------------------------
	
	//------------------------------------------------------------------------------
	// le constructeur
	//------------------------------------------------------------------------------
	function ProgressSection(title, start, end, numSteps, fractionOfParentStep) {
		this.start = start;
		this.end = end;
		this.numSteps = numSteps;
		this.fractionPerStep = (end-start)/numSteps;
		this.stepsComplete = 0;
		this.curStepFractionComplete = 0;
		this.fractionOfParent = fractionOfParentStep;
		this.title = title;
	} // ProgressSection
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.stepComplete
	//------------------------------------------------------------------------------
	ProgressSection.prototype.stepComplete = function() {
		this.stepsComplete++;
		this.curStepFractionComplete = 0;
	} // ProgressSection.prototype.stepComplete
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.stepFractionComplete
	// permet de dfinir une partie de la section actuelle comme complte
	//------------------------------------------------------------------------------
	ProgressSection.prototype.stepFractionComplete = function(fraction) {
		this.curStepFractionComplete = fraction;
	} // ProgressSection.prototype.stepFractionComplete
	
	//------------------------------------------------------------------------------
	// ProgressSection.prototype.getTotalFractionComplete
	//------------------------------------------------------------------------------
	ProgressSection.prototype.getTotalFractionComplete = function() {
		return this.start + (this.stepsComplete * this.fractionPerStep) + (this.curStepFractionComplete * this.fractionPerStep);
	} // ProgressSection.prototype.getTotalFractionComplete
	
	//------------------------------------------------------------------------------
	// dfinier la barre de progression
	//------------------------------------------------------------------------------
	var pbar = new ProgressBar("Prparations ... ... ... ... ... ... ... ... ... ... ... ... ... ... ...", "La charte de couleurs est cre");
	
	//////////////////  Progressbar  fin  ////////////////////////////////////////////////////////////////
	
	// afficher la barre de progression dfinie
	pbar.open();
	// le nombre de pas et la valeur de la variable du compteur
	var numIterations = (mN*mN);
	var st  = 1;
	var ctr = 0;
}

// une boucle  travers les ranges
var ctr = 0;
for (var i=0; i<mN; i++) {
	if (rDec == 3 && nFix != 3) {
		// rafrachir l'affichage de progression
		pbar.updateText("Range " + (i+1) + " (de " + mN + ")  |  bloc " + ctr + " (de " + (mN*mN) + ")");
	}
	y1 = y1+yOff; // la position verticale de la range actuelle
	x1 = xD;      // la valeur de dpart horizontal de la colonne
	if (nFix == 0) {
		// augmenter les valeurs variables par celle du pas
		if      (pt1 == 0) { c = c + sPc; }
		else if (pt1 == 1) { m = m + sPc; }
		else if (pt1 == 2) { y = y + sPc; }
		else if (pt1 == 3) { k = k + sPc; }
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		// rtablir les valeurs variables  la valeur de dpart
		if      (pt3 == 0) { c = xPc; }
		else if (pt3 == 1) { m = xPc; }
		else if (pt3 == 2) { y = xPc; }
		else if (pt3 == 3) { k = xPc; }
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	if (nFix == 1) {
		// augmenter les valeurs variables par celle du pas
		if      (pt2 == 0) { c = c + sPc; }
		else if (pt2 == 1) { m = m + sPc; }
		else if (pt2 == 2) { y = y + sPc; }
		else if (pt2 == 3) { k = k + sPc; }
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 2) {
		// augmenter une valeur variable par celle du pas
		if      (pt3 == 0) { c = c + sPc; }
		else if (pt3 == 1) { m = m + sPc; }
		else if (pt3 == 2) { y = y + sPc; }
		else if (pt3 == 3) { k = k + sPc; }
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	else if (nFix == 3) {
		// rtablir une valeur variable  sa valeur de dpart
		if      (pt4 == 0) { c = xPc; }
		else if (pt4 == 1) { m = xPc; }
		else if (pt4 == 2) { y = xPc; }
		else if (pt4 == 3) { k = xPc; }
	}
	// crer les nuances et les blocs de la range actuelle
	for (var j=0; j<mN; j++) {
		var curValues = [c,m,y,k];
		if (makeSure) {
			var testName = "C=" + c + " M=" + m + " " + yChar + "=" + y + " " + kChar + "=" + k;
			try {
				testColor = curDoc.colors.itemByName(testName).name;
				curColor  = curDoc.colors.itemByName(testName);
			}
			catch (e) {
				curColor  = curDoc.colors.add({colorValue:curValues});
			}
		}
		else {
			curColor = curDoc.colors.add({colorValue:curValues});
		}
		// crer le bloc actuel
		curDoc.rectangles.add({geometricBounds:[y1,x1,y1+fH,x1+fW], fillColor:curColor, fillTint:100, strokeColor:"None"});
		// augmenter la position X par la valeur de dcalage
		x1 = x1+xOff;
		// 
		if (nFix == 0) {
		// augmenter une valeur variable par celle du pas
			if      (pt3 == 0) { c = c + sPc; }
			else if (pt3 == 1) { m = m + sPc; }
			else if (pt3 == 2) { y = y + sPc; }
			else if (pt3 == 3) { k = k + sPc; }
		}
		// augmenter une valeur variable par celle du pas
		if      (pt4 == 0) { c = c + sPc; }
		else if (pt4 == 1) { m = m + sPc; }
		else if (pt4 == 2) { y = y + sPc; }
		else if (pt4 == 3) { k = k + sPc; }
		
		if (rDec == 1) {
			// appeler la fonction pour afficher l'information aprs chaque dixime complt
			ctr++;
			if (ctr > testVal) {
				showProgress(ctr, mN*mN);
				testVal = testVal+tenPc;
			}
		}
		else if (rDec == 3 && nFix != 3) {
			ctr++;
			// rafrachir la barre de progression 
			pbar.updateText("Range " + (i+1) + " (de " + mN + ")  |  bloc " + ctr + " (de " + (mN*mN) + ")");
			pbar.sectionStepFractionCompleted(st/numIterations);
			st++;
		}
	}
	// arrter l'excution aprs la premire range s'il y a trois composants fixes
	if (nFix == 3) { break; }
	// appeler la fonction pour afficher l'information quand il faut montrer l'tat aprs chaque range
	if (rDec == 2) {
		if (i < mN-1) {
			showProgress((i+1)*mN, mN*mN);
		}
	}
}

if (rDec == 3 && nFix != 3) {
	// fermer la barre de progression
	pbar.close();
}

// rendre le document visible
if (mN > nF) {
	curDoc.windows.add();
}

// appeler la fonction pour rtablir les rglages initiales
resetAsBefore();


////////////////////////////// les fonctions  ////////////////////////////////////////////

// la fonction qui prpare les informations
function getPrefs() {
	var allPrefs = "";
	// lire le fichier contenant les valeurs enregistres
	var f = new File("~/Library/Preferences/charte401.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// prparer et afficher le dialogue
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth0 =  58;
	var labelWidth1 = 125;
	var labelWidth2 =  85;
	var labelWidth3 = 215;
	var labelWidth4 = 225;
	var fieldWidth  =  32;
	var aDialog = app.dialogs.add({name:"Charte de couleurs"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Des valeurs fixes pour les composants activs"});
							staticTexts.add({staticLabel:" ", minWidth:18});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var cChk = checkboxControls.add({staticLabel:"Cyan",    checkedState:cSt, minWidth:labelWidth2});
							var cVal = integerEditboxes.add({editValue:cFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var mChk = checkboxControls.add({staticLabel:"Magenta", checkedState:mSt, minWidth:labelWidth2});
							var mVal = integerEditboxes.add({editValue:mFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var yChk = checkboxControls.add({staticLabel:yelloCol,  checkedState:ySt, minWidth:labelWidth2});
							var yVal = integerEditboxes.add({editValue:yFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth1});
							var kChk = checkboxControls.add({staticLabel:blackCol,  checkedState:kSt, minWidth:labelWidth2});
							var kVal = integerEditboxes.add({editValue:kFix, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
						}
					}
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Des valeurs variables pour les autres composants", minWidth:fieldWidth});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La valeur initiale", minWidth:labelWidth3});
							var xValField = realEditboxes.add({editValue:xVal, minimumValue:0, maximumValue:90, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Le pas", minWidth:labelWidth3});
							var sValField = realEditboxes.add({editValue:stVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"La valeur finale", minWidth:labelWidth3});
							var zValField = realEditboxes.add({editValue:zVal, minimumValue:10, maximumValue:100, minWidth:fieldWidth});
							staticTexts.add({staticLabel:"%  "});
							staticTexts.add({staticLabel:" "});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"(val. finale moins val. initiale = multiple du pas)"});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Largeur et hauteur d'un bloc", minWidth:labelWidth4});
				var widthField = realEditboxes.add({editValue:wdVal, minimumValue:1, maximumValue:25, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Distance entre ranges et colonnes", minWidth:labelWidth4});
				var distField = realEditboxes.add({editValue:dVal, minimumValue:0, maximumValue:10, minWidth:fieldWidth});
				staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					staticTexts.add({staticLabel:" ", minWidth:66});
					with(refButtons = radiobuttonGroups.add()) {
						radiobuttonControls.add({staticLabel:"sans rafrachissement", checkedState:rb01});
						radiobuttonControls.add({staticLabel:"activer le rafrachissement", checkedState:rb02});
					}
					staticTexts.add({staticLabel:" ", minWidth:62});
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Comment informer pendant l'excution"});
							staticTexts.add({staticLabel:" ", minWidth:58});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"", minWidth:66});
							with(msgButtons = radiobuttonGroups.add()) {
								radiobuttonControls.add({staticLabel:"pas d'info", checkedState:rb03});
								radiobuttonControls.add({staticLabel:"un message aprs chaque dixime", checkedState:rb04});
								radiobuttonControls.add({staticLabel:"un message aprs chaque range", checkedState:rb05});
								radiobuttonControls.add({staticLabel:"une barre de progression", checkedState:rb06});
							}
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var cDec    = cChk.checkedState;
		var cPc     = cVal.editValue;
		var mDec    = mChk.checkedState;
		var mPc     = mVal.editValue;
		var yDec    = yChk.checkedState;
		var yPc     = yVal.editValue;
		var kDec    = kChk.checkedState;
		var kPc     = kVal.editValue;
		var xPc     = xValField.editValue;
		var sPc     = sValField.editValue;
		var zPc     = zValField.editValue;
		var frSize  = widthField.editValue;
		var distVal = distField.editValue;
		var refDec  = refButtons.selectedButton;
		var msgDec  = msgButtons.selectedButton;
		// supprimer le dialogue
		aDialog.destroy();
		// la liste des rglages...
		var prefsList = new Array (cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, xPc, sPc, zPc, frSize, distVal, refDec, msgDec);
		// ... la transformer en une chane de texte...
		var prefString = prefsList.join("\n");
		// ... et l'envoyer  la fonction qui l'crit dans un fichier
		writeResult(prefString);
		// passer le choix de l'utilisateur aux variables
		var col1 = col2 = col3 = col4 = "";
		var fixTotal = 0;
		if (cDec) { fixTotal = fixTotal+1; }
		if (mDec) { fixTotal = fixTotal+2; }
		if (yDec) { fixTotal = fixTotal+4; }
		if (kDec) { fixTotal = fixTotal+8; }
		if (fixTotal == 0) {
			var nFix = 0;
			var col1 = "Cyan";
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 1) {
			var nFix = 1;
			var col2 = "Magenta";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 2) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 3) {
			var nFix = 2;
			var col3 = yelloCol;
			var col4 = blackCol;
		}
		else if (fixTotal == 4) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 5) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = blackCol;
		}
		else if (fixTotal == 6) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = blackCol;
		}
		else if (fixTotal == 7) {
			var nFix = 3;
			var col4 = blackCol;
		}
		else if (fixTotal == 8) {
			var nFix = 1;
			var col2 = "Cyan";
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 9) {
			var nFix = 2;
			var col3 = "Magenta";
			var col4 = yelloCol;
		}
		else if (fixTotal == 10) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = yelloCol;
		}
		else if (fixTotal == 11) {
			var nFix = 3;
			var col4 = yelloCol;
		}
		else if (fixTotal == 12) {
			var nFix = 2;
			var col3 = "Cyan";
			var col4 = "Magenta";
		}
		else if (fixTotal == 13) {
			var nFix = 3;
			var col4 = "Magenta";
		}
		else if (fixTotal == 14) {
			var nFix = 3;
			var col4 = "Cyan";
		}
		else if (fixTotal == 15) {
			alert ("Il ne faut pas dfinir les quatre composants comme fixe.", "Stop");
			exit();
		}
		// die Eingabe testen
		if (xPc != (Math.floor(xPc))) {
			alert ("Valeur initiale: uniquement des nombres *entiers* sont admis.", "Stop");
			exit();
		}
		if (sPc != (Math.floor(sPc))) {
			alert ("Le pas: pas de positions dcimales, svp.", "Stop");
			exit();
		}
		if (zPc != (Math.floor(zPc))) {
			alert ("La valeur finale: doit tre un nombre *entier*.", "Stop");
			exit();
		}
		if (xPc>zPc) {
			alert ("La valeur initiale ne peut pas tre plus grande que la valeur finale.", "Stop");
			exit();
		}
		if ((zPc-xPc)<sPc) {
			alert ("Entre la valeur initiale et la valeur finale il doit y avoir au moins une valeur \"pas\".", "Stop");
			exit();
		}
		if ((zPc-xPc)%sPc != 0) {
			alert ("*Valeur finale moins valeur initiale* \ndoit tre un multiple du pas.\n\n( par exemple\nvaleur initiale: " + xPc + " | valeur finale: " + (zPc-((zPc-xPc)%sPc)) + "\nou \nvaleur initiale: " + (zPc%sPc) + " | valeur finale: " + zPc + " )", "Stop");
			exit();
		}
		return [cDec, mDec, yDec, kDec, cPc, mPc, yPc, kPc, col1, col2, col3, col4, nFix, xPc, sPc, zPc, frSize, distVal, refDec, msgDec];
	}
	else {
		aDialog.destroy();
		exit();
	}
}

// informer l'utilisateur sur l'tat actuel
function showProgress(n, nn) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Nombre de blocs:  " + n + "  (de " + nn + ")");
	dlog.show();
	$.sleep(1000);
	dlog.close(); 
}

// rtablir les rglages initiales
function resetAsBefore() {
	if (noDoc == false) {
		// rtablir le point zro (si ncessaire) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		// rtablir les units de mesure (si ncessaire)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// verrouiller le calque (si ncessaire)
		if (isLocked) {
			curLayer.locked = true;
		}
	}
	// das Auffrischen aktivieren ...
	app.scriptPreferences.enableRedraw = true;
}

// crire le rsultat dans un fichier
function writeResult(curPrefs) {
	var f = new File("~/Library/Preferences/charte401.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}